#include "system_parse.h"

typedef struct {
      unsigned char     curr_type;
      unsigned char     frame_num;
      unsigned char     frame_part;
      unsigned char     num_of_parts;
      int               size;
      int               skip_15_offset;
} entity;

/* Reads an integer */
int READ_INT(int fildes)
{
        unsigned char cp[4]; 
        read(fildes,cp,4);
        return (((int)(cp[0])) << 24 )
                +(((int)(cp[1])) << 16 )
                +(((int)(cp[2])) << 8  )
                +(((int)(cp[3])));
}


void main(int argc, char *argv[]) 
{
	int i = 1, fd, fd2, sz;
	unsigned char *buffer, trash[4], first[4], prev='I';
		

	
	fd = open(argv[1], O_RDONLY);
	fd2 = open(argv[2], O_CREAT|O_WRONLY, 0644);
	
	if ((fd < 0) || (fd2 < 0)) 
	{
		perror("open failed");
		exit(1);
	}

	while (i != 0)
	{
		i = read(fd, &first[0], 4);
		sz = READ_INT(fd);
		i = read(fd, &trash[0], 4);

		buffer = (unsigned char *) malloc (sz);
		read(fd, buffer, sz);
		
		write(fd2, buffer, sz);
		free(buffer);
				
		if (prev == 'B' && first[0] == 'I') 
		{
			printf("\n");
			printf("%c%x", first[0], first[2]);
			prev = first[0];
		}
		else
		{
			printf("%c%x", first[0], first[2]);
			prev = first[0];
		}
	}

	close (fd);
	close (fd2);

}
